#include <sys/param.h>

#include <a.out.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

static void
cksum(s, e)
	register u_int *s, *e;
{
	register u_int *p, sum;

	sum = 0;
	for (p = s; p < e; p++)
		sum = ((sum << 1) | (sum >> 31)) ^ *p;
	printf("sum over [%x..%x) = %x\n", (u_long)s, (u_long)e, sum);
}

docksum(fd, off, size)
	int fd;
	u_long off, size;
{
	char *buf;

	buf = malloc(size);
	if (buf == NULL) {
		perror("malloc");
		exit(1);
	}
	if (lseek(fd, off, L_SET) < 0) {
		perror("lseek");
		exit(1);
	}
	if (read(fd, buf, size) != size) {
		perror("read");
		exit(1);
	}
	cksum(buf, buf + size);
	free(buf);
}

main()
{
	struct exec exec;

	if (read(fileno(stdin), &exec, sizeof(exec)) != sizeof(exec)) {
		perror("exec read");
		exit(1);
	}
	docksum(fileno(stdin), N_TXTOFF(exec), exec.a_text);
	docksum(fileno(stdin), N_DATOFF(exec), exec.a_data);
	exit(0);
}
