#include <sys/param.h>

#include <sys/time.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <netinet/udp_var.h>

#include <ctype.h>
#include <errno.h>
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#include <memory.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <lbl/gnuc.h>

struct outdata {
        u_char seq;             /* sequence number of this packet */
        u_char ttl;             /* ttl packet left with */
        struct timeval tv;      /* time packet left */
};


void
frob(register struct ip *ip)
{
	register struct udphdr *up;
	register struct outdata *outdata;

	printf("\n");
	printf("ip: hl %d, v %d, tos %d, len %d, id %d, off %d, ttl %d, p %d\n",
	    ip->ip_hl,
	    ip->ip_v,
	    ip->ip_tos,
	    ip->ip_len,
	    ip->ip_id,
	    ip->ip_off,
	    ip->ip_ttl,
	    ip->ip_p);
	printf("sum 0x%x\n", ip->ip_sum);
	printf("src 0x%x\n", ip->ip_src.s_addr);
	printf("dst 0x%x\n", ip->ip_dst.s_addr);

	up = (struct udphdr *)(ip + 1);
	printf("udp: sport %d, dport %d, ulen %d\n",
	    up->uh_sport,
	    up->uh_dport,
	    up->uh_ulen);
	printf("sum 0x%x\n", up->uh_sum);

	outdata = (struct outdata *)(up + 1);
	printf("outdata: seq %d, ttl %d, tv %d.%d\n",
	outdata->seq,
	outdata->ttl,
	outdata->tv.tv_sec,
	outdata->tv.tv_usec);

}
