/*
 * Copyright (c) 1992, 1993, 1994, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * This software was developed by the Computer Systems Engineering group
 * at Lawrence Berkeley Laboratory under DARPA contract BG 91-66 and
 * contributed to Berkeley.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Lawrence Berkeley Laboratory and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) $Header: bootp.c,v 1.7 95/04/12 02:08:42 leres Exp $ (LBL)
 */

#include <sys/types.h>
#include <sys/time.h>

#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>

#include <errno.h>
#include <string.h>

#ifdef LBL
#include <lbl/os-proto.h>
#endif

#include "bootbootp.h"
#include "tr.h"

/* Data section of the probe packet */
struct outdata {
	u_char seq;		/* sequence number of this packet */
	u_char ttl;		/* ttl packet left with */
	struct timeval tv;	/* time packet left */
};

/* Fetch required icmp information */
void
tr(d, target)
	register struct iodesc *d;
	register char *target;
{
	register struct outdata *outdata;
	register void *pkt;
	register int len;
	register int cc;
	struct {
		u_char header[HEADER_SIZE];
		struct outdata woutdata;
	} wbuf;
	struct timezone tz;

bzero(&wbuf, sizeof(wbuf));

	outdata = &wbuf.woutdata;
	pkt = outdata;

	bzero(outdata, sizeof(*outdata));
	outdata->seq = 1;
	outdata->ttl = 1;
	(void)gettimeofday(&outdata->tv, &tz);
outdata->tv.tv_sec = 123;
outdata->tv.tv_usec = 456789;

	d->myport = 39156;
	d->destport = 32768 + 666; /* start udp dest port # for probe packets */
	d->destport += 1;
	d->myip =   0x83f3011a;
	d->destip = 0x83f30115;

	len = sizeof(*outdata);
	cc = sendudp(d, pkt, len);
	printf("tr sendudp says %d\n", cc);
pkt -= 28;
frob(pkt);
}

