#include <sys/param.h>

#include <netinet/in.h>
#include <netinet/in_systm.h>

#ifdef notdef
#include <sun4c/mmu.h>
#else
#define DVMABASE        (0-(1024*1024))
#endif
#include <machine/ctlreg.h>

#ifdef LBL
#include <lbl/os-proto.h>
#endif

#include <machine/bsd_openprom.h>

#include "bootbootp.h"

/*
 * Magic hack: SunOS kernel can panic unless this is here.
 * For some reason, they do the "map the kernel into all contexts"
 * by reading an internal pmeg data structure based on each segment
 * map entry.  If the segment map entry is sufficiently wrong, this
 * indexes off the end of the data structure.  As it happens, the
 * SunOS kernel leaves a bogus entry for exactly one virtual
 * segment, the one they use for DVMA.  So, we just have to set
 * the DVMA segment to a valid, not-in-use pmeg.
 */
void
_fixsegmap()
{
	register int i, minpmeg, pmeg;

	minpmeg = 256;
	for (i = OPENPROM_STARTVADDR; i < OPENPROM_ENDVADDR; i += 256 * 1024) {
		__asm __volatile("lduba [%1]%2,%0" : "=r" (pmeg) :
		    "r" (i), "n" (ASI_SEGMAP));
		if (pmeg != 0 && pmeg < minpmeg)
			minpmeg = pmeg;
	}
	__asm __volatile("stba %0,[%1]%2" : :
	    "r" (minpmeg - 1), "r" (DVMABASE), "n" (ASI_SEGMAP));
}
