/*
 * Copyright (c) 1992, 1994, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * This software was developed by the Computer Systems Engineering group
 * at Lawrence Berkeley Laboratory under DARPA contract BG 91-66 and
 * contributed to Berkeley.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Lawrence Berkeley Laboratory and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) $Header: start.s,v 1.9 95/05/15 20:01:39 leres Exp $ (LBL)
 */

#include <machine/psl.h>
#include <machine/ctlreg.h>

	.globl	start
start:
	/*
	 * We are running at 0x4000, but we want to run at RELOC.
	 * We assume that copying from 0x4000 to RELOC is safe and
	 * does the right thing.  Whoever sets RELOC has to arrange
	 * that.
	 *
	 * N.B.: %o0 contains promvec, so leave it alone.
	 */
	set	RELOC, %l7

	set	0x4000, %l0
	mov	%l7, %l1
	set	_edata, %l2
0:
	ld	[%l0], %l3
	inc	4, %l0
	inc	4, %l1
	cmp	%l1, %l2
	bne	0b
	 st	%l3, [%l1 - 4]

	/*
	 * Got ourselves moved, now jump to ourselves.
	 */
	set	1f, %l0
	jmp	%l0
	 nop
1:

	/*
	 * Enable traps and interrupts, stash promvec, make stack,
	 * zero bss, and go.  Note that promvec is in the data segment
	 * so that we do not clobber it with the bzero.
	 */
	rd	%psr, %o1
	or	%o1, PSR_ET, %o1
	andn	%o1, PSR_PIL, %o1
	or	%o1, (13 << PSR_PILSHIFT), %o1	! 13 to allow L1-A
	wr	%o1, 0, %psr
	sethi	%hi(_promvec), %o1
	st	%o0, [%o1 + %lo(_promvec)]
	nop

	save	%l7, -96, %sp

	set	_edata, %o0		! bzero(edata, end - edata)
	set	_end, %o1
	call	_bzero
	 sub	%o1, %o0, %o1

	call	_prommain
	 nop

	ret
	restore

	.globl	___main
___main:
	retl
	 nop

	.globl	___builtin_saveregs
___builtin_saveregs:
	st	%i0, [%fp + 0x44]	! fr->fr_argd[0]
	st	%i1, [%fp + 0x48]	! fr->fr_argd[1]
	st	%i2, [%fp + 0x4c]	! fr->fr_argd[2]
	st	%i3, [%fp + 0x50]	! fr->fr_argd[3]
	st	%i4, [%fp + 0x54]	! fr->fr_argd[4]
	retl
	 st	%i5, [%fp + 0x58]	! fr->fr_argd[5]

	.globl	_call
_call:
	save	%sp, -96, %sp
#ifdef notdef
	/* XXX Don't enable the cache (this doesn't work on the Classic/LX) */
	set	AC_SYSENABLE, %l0
	lduba	[%l0] ASI_CONTROL, %l1
	andn	%l1, SYSEN_CACHE, %l1
	stba	%l1, [%l0] ASI_CONTROL
#endif
	rd	%psr, %l0
	andn	%l0, PSR_ET, %l1
	or	%l1, PSR_PIL, %l1
	wr	%l1, 0, %psr
	 sethi	%hi(_promvec), %o0
	 ld	[%o0 + %lo(_promvec)], %o0
	 clr	%o1			! for SunOS, a null dvec
	call	%i0
	 clr	%o2			! also for SunOS, a null func ptr
	wr	%l0, 0, %psr
	 nop
	 nop
	 nop
	ret
	 restore

	.data
	.globl	_promvec
_promvec:
	.word	0
